<template>
  <b-container class="large-container">
    <!--
      We display a special graphic if the user is not logged in,
      or if they haven't submitted any watch lists yet.
    -->
    <div v-if="!isAuthenticated || status === Status.EMPTY">
      <div class="d-flex justify-content-center no-content">
        <img
          class="mr-4"
          src="../assets/watch-list-banner.svg"
        >
        <div
          style="max-width: 400px;"
          class="d-flex flex-column text-justify ml-4"
        >
          <h1>Track Objects of Interest</h1>
          <span> ANTARES Watch Lists help you track ZTF alerts at particular locations.</span>
          <b-button
            :to="{ name: 'watchListCreate' }"
            class="mt-4"
            variant="primary"
          >
            <span v-if="isAuthenticated">Create your first Watch List</span>
            <span v-else>Login to create your first Watch List</span>
          </b-button>
        </div>
      </div>
    </div>
    <!--
      Otherwise, we display the table of watch lists or an error message--if there was a
      problem loading their watch lists.
    -->
    <div v-else>
      <div v-if="status === Status.LOADING">
        <content-loader-table
          :height="perPage * 30"
          :num-rows="perPage"
        />
      </div>
      <div v-else-if="status === Status.ERROR">
        <b-list-group>
          <b-list-group-item variant="danger">
            <h5>Error Loading Watch Lists</h5>
            <p>There was an error loading your watch lists.</p>
            <pre>{{ JSON.stringify(error, null, 2) }}</pre>
          </b-list-group-item>
        </b-list-group>
      </div>
      <div v-show="status === Status.SUCCESS">
        <div class="d-flex justify-content-between">
          <div>
            <b-button
              :to="{ name: 'watchListCreate' }"
              class="mr-2"
              size="sm"
              variant="success"
            >
              <font-awesome-icon :icon="['far', 'plus-square']" /> <strong>New Watch List</strong>
            </b-button>
            <b-button
              :disabled="!selected.length"
              size="sm"
              variant="danger"
              @click="deleteWatchLists(selected)"
            >
              <font-awesome-icon :icon="['far', 'minus-square']" />
              <strong>Delete Watch List(s)</strong>
            </b-button>
          </div>
          <div class="d-flex align-items-baseline">
            <b-form inline>
              <b-form-select
                v-model="perPage"
                :options="pageOptions"
                class="mr-2"
                size="sm"
              />
            </b-form>
            <b-pagination
              v-model="currentPage"
              :per-page="perPage"
              :total-rows="count"
              align="right"
              size="sm"
            />
          </div>
        </div>
        <b-table
          ref="table"
          :current-page="currentPage"
          :items="fetchWatchLists"
          :fields="fields"
          :per-page="perPage"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          bordered
          hover
          select-mode="range"
          selectable
          small
          striped
          @row-selected="onRowSelected"
        >
          <template #cell(name)="data">
            <b-link :to="{ name: 'watchListDetail', params: { watchListId: data.item.id } }">
              {{
                data.item.name
              }}
            </b-link>
          </template>
          <template #cell(actions)="data">
            <b-link :to="buildMatchingLociRoute(data.item)">
              View Loci
            </b-link>
          </template>
        </b-table>
      </div>
    </div>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';
import { BvTableCtxObject } from 'bootstrap-vue';
import { WatchList } from '@/common/types';
import { WatchListService } from '@/api';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
  EMPTY = 'EMPTY', // Like success but no results returned
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
  },

  data() {
    return {
      Status,
      count: 0,
      currentPage: 1,
      error: {},
      fields: [
        {
          key: 'name',
          label: 'Name',
          sortable: true,
        },
        {
          key: 'description',
          label: 'Description',
          sortable: true,
        },
        {
          key: 'slack_channel',
          label: 'Slack Channel',
          sortable: true,
        },
        {
          key: 'created_at',
          label: 'Created At (UTC)',
          sortable: true,
        },
        {
          key: 'actions',
          label: 'Actions',
        },
      ],
      perPage: 5,
      pageOptions: [5, 10, 25, 50, 100],
      selected: [],
      sortBy: 'created_at',
      sortDesc: true,
      status: Status.LOADING,
    };
  },

  computed: {
    ...mapGetters(['isAuthenticated']),
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    rows(): number {
      return this.count;
    },
  },

  methods: {
    buildMatchingLociRoute(watchList: WatchList): object {
      return {
        name: 'locusList',
        query: {
          query: JSON.stringify({
            filters: [
              {
                type: 'terms',
                field: 'watch_list_ids',
                value: [watchList.id],
                text: `Watch List: ${watchList.name}`,
              },
            ],
          }),
        },
      };
    },

    async deleteWatchLists(watchLists: WatchList[]) {
      await Promise.all(watchLists.map(async (watchList) => WatchListService.delete(watchList.id)));
      (<any> this.$refs.table).refresh();
    },

    async fetchWatchLists(ctx: BvTableCtxObject) {
      this.status = Status.LOADING;
      try {
        const { data: watchLists, meta } = await WatchListService.list({
          page: {
            limit: ctx.perPage,
            offset: (ctx.currentPage - 1) * ctx.perPage,
          },
          ...(ctx.sortBy && { sort: (ctx.sortDesc ? '-' : '') + ctx.sortBy }),
        });
        this.count = meta.count;
        if (meta.count === 0) {
          this.status = Status.EMPTY;
        } else {
          this.status = Status.SUCCESS;
        }
        return watchLists;
      } catch (errors) {
        /* eslint-disable-next-line prefer-destructuring */
        this.error = errors[0];
        this.status = Status.ERROR;
      }
      return null;
    },

    onRowSelected(items: []) {
      this.selected = items;
    },
  },
});
</script>

<style scoped>
.no-content {
  margin-top: 100px;
}
</style>
